Component({
  properties: {
    title: {
      type: String,
      value: '标题'
    },
    popupHeight: {
      type: String,
      value: '400rpx'  // 弹窗高度，默认400rpx
    },
    isVisible: {
      type: Boolean,
      value: false // 是否显示弹窗
    }
  },

  data: {
    popupStyle: '', // 动态控制弹窗的样式
  },

  methods: {
    // 显示弹窗
    showPopup() {
      this.setData({
        isVisible: true
      });
      this.animatePopup(); // 启动动画
    },

    // 隐藏弹窗
    closePopup() {
      this.setData({
        isVisible: false
      });
    },

    // 弹窗动画，缓慢升起
    animatePopup() {
      this.setData({
        popupStyle: 'bottom: 0;' // 动画结束后将弹窗位置设置为0，显示出来
      });
    }
  },

  observers: {
    'isVisible': function(isVisible) {
      if (isVisible) {
        // 显示时，触发动画
        this.animatePopup();
      } else {
        // 隐藏时，复位位置
        this.setData({
          popupStyle: 'bottom: -100%;' // 复位弹窗位置到屏幕底部
        });
      }
    }
  }
});
