const Cache = require('../../utils/cache.js');
Page({
  data: {
    bubbleColor: '',
    animationData: {},
    themeColor: "#406Eff'",
    textColor: '#ffffff',
    navColor: 'transparent',
    messages: [
      '嘿嘿，快点给我个赞吧！😊',
      '你真是太可爱了！😘',
      '哦哟！你又点了我呀！🌸',
      '小心，我可是会“吃”掉你的点赞哦！😜',
      '哇哦，点我点我！💖',
      '再点一次，看看会发生什么！😏',
      '嗯？是不是想调皮一下？🤭',
      '再来一次看看，我会变成什么！👀',
      '你的小手真快！👏',
      '你猜我会说什么？🎤',
      '别停，我喜欢这个节奏！🎶',
      '嘿！你是不是在偷笑？😁',
      '你点的太快啦，我都没反应过来！😂',
      '你这只调皮的小手，停不下来呀！😝',
      '快！再点一次，看看我会变成什么！✨',
      '你是不是偷偷在逗我笑呢？😂',
      '点的真快，我都追不上啦！⚡',
      '是不是我也能跟你玩一会儿呢？🙃',
      '就知道你会点，果然是最聪明的！🧠',
      '点我一次，我就给你一个惊喜！🎉',
      '你真会玩，快告诉我，下一步怎么办？😎',
      '哈哈，别停！你快让我笑掉了！😂',
      '你在开玩笑吧？点一下我就这么可爱！🐰',
      '好呀，继续！我也想看点什么有趣的！👾',
      '你点的真好，奖励你一个小可爱！🎁',
      '我就在这里等你哦，快来再点我一次！💫',
      '哇！你的手指好灵活，能不能教我呀？🐾',
      '噢！这是什么神奇的力量？点我就开心！🎈',
      '我已经准备好迎接更多的点击啦！🚀',
      '快再点一次，我的表情会变哦！🤩',
      '你真是个点心高手！请收下我的点赞！👍',
      '嘿，你敢再点一次吗？我可是有点小脾气的哦！👿',
      '你知道吗？每次点击我都心跳加速！💓',
      '我知道你会来，快给我一个大大的“赞”！🌟',
      '是不是点我才能找到宝藏？🎁',
      '你点我一次，我就会笑出声来！🤣',
      '小手别停，我有无限的惊喜等着你！🎉',
      '哇哦，点击真有魔力，来再试一次！🔮',
      '这就是你的小秘密吗？再来一遍！🤭'
    ]
  },

  onShow() {
    this.setNavigationBarColor();
  },
  setNavigationBarColor() {
    const themeColor = Cache.get('themeColor') || '#406Eff';
    const textColor = Cache.get('textColor') || '#ffffff';
    this.setData({
      themeColor,
      textColor
    })
    this.changeBubbleColor(themeColor)
  },

  changeBubbleColor(themeColor) {
    const newBubbleColor = this.adjustColor(themeColor, 20);
    this.setData({
      bubbleColor: newBubbleColor
    });
  },
  adjustColor(hex, amount) {
    const color = {
      r: Math.min(255, parseInt(hex.slice(1, 3), 16) + amount),
      g: Math.min(255, parseInt(hex.slice(3, 5), 16) + amount),
      b: Math.min(255, parseInt(hex.slice(5, 7), 16) + amount)
    };
    // 将 RGB 转换回十六进制
    return `#${[color.r, color.g, color.b].map(c => c.toString(16).padStart(2, '0')).join('')}`;
  },
  onRandomMessage: function () {
    const randomIndex = Math.floor(Math.random() * this.data.messages.length);
    const randomMessage = this.data.messages[randomIndex];
    wx.showToast({
      title: randomMessage,
      icon: 'none',
      duration: 2000
    });
  }
})