const Cache = require('../../utils/cache.js');
Page({
  data: {
    bubbleColor: '',
    tagStyle: {
      blockquote: 'max-width:100%;background:#f9f9f9;padding:5px 10px;border-left:3px solid #42b883;margin:10px 0px;',
      table: 'width:100%;border:1px #eee solid;',
      td: 'border:1px #eee solid;text-align:center;',
      th: 'border:1px #eee solid;background-color:#ffc09f;',
    },
    likeList:[{avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'},
    {avatar:'http://tmp/mfn9zENTWJ5m547ef7ea1274884529774cc094a71cc0.jpeg',poster:'PengSir'}],
    animationData: {},
    themeColor: "#406Eff'",
    textColor: '#ffffff',
    navColor: 'transparent',
    popupVisible: false,
    displayedText: '这是文章的摘要',
    tagStyle: {
      blockquote: 'max-width:100%;border-radius:5px;background:#eee;padding:5px;',
      table: 'width:100%;border:1px #eee solid;',
      td: 'border:1px #eee solid;text-align:center;',
      th: 'border:1px #eee solid;background-color:#ffc09f;',
    },
    data: {
      "article": {
        "title": "文章的标题",
        "date": "2022-06-04 10:42:12",
        "id": 54215,
        "sort_id": -1,
        "sort_name": "",
        "type": "blog",
        "author_id": "1",
        "author_name": "snowsun",
        "author_avatar": "/images/banner.png",
        "content": "<p>文章的内容</p>",
        "excerpt": "这里是文章的摘要",
        "cover": "",
        "views": 2,
        "comnum": 0,
        "like_count": 1,
        "top": "n",
        "sortop": "n",
        "tags": [{
          "name": "emlog",
          "url": "http://localhost/?tag=emlog"
        }],
        "fields": {
          "price": "9.9",
          "color": "#ffffff",
        }
      },
    }
  },
  onLoad(options) {
    this.getInfo(options.id, options.password);
    this.getLikelist(options.id)
  },


  onShow() {
    this.setNavigationBarColor();
  },
  onPageScroll: function (e) {
    if (e.scrollTop > 10) {
      this.setData({
        navColor: this.data.themeColor
      })
    } else {
      this.setData({
        navColor: 'transparent'
      })
    }
    if (e.scrollTop > 439) {
      this.setData({
        isTop: false
      })
    } else {
      this.setData({
        isTop: true
      })
    }
  },
  showPopup() {
    this.setData({
      popupVisible: true
    });
  },
  getLikelist(id){
    getApp().api.getLikelist({
      id: id
    }).then((res) => {
      this.setData({
        likeList:res.data.likes
      })
    })
  },
  addLike(){
    const userInfo = Cache.get('userInfo')||'';
    const { likeList } = this.data;
    getApp().api.addLike({
      gid: this.data.data.article.id,
      name: userInfo.nickName,
      avatar:userInfo.avatarUrl
    }).then((res) => {
      this.setData({
        'data.article.like_count':this.data.data.article.like_count+1,
        likeList: [...likeList, { avatar: userInfo.avatarUrl, poster: userInfo.nickName }]
      })
      wx.showToast({
        title: res.msg,
        icon: res.code === 0 ? 'success' : 'none'
      })
    }).catch((err) => {
      console.error(err);
      wx.showToast({
          title: err.msg || '操作失败',
          icon: 'none'
      });
  });
  },
  
  getInfo(id, password) {
    getApp().api.getInfo({
      id: id,
      password: password
    }).then((res) => {
      wx.stopPullDownRefresh();
      if (!res.data) {}
      if (res.data) {
        const tagClassMap = {
          img: 'rich-img',
          h1: 'rich-h1',
          h2: 'rich-h2',
          h3: 'rich-h3',
          h4: 'rich-h4',
          h5: 'rich-h5',
          h6: 'rich-h6',
          hr: 'rich-hr',
          a: 'rich-a'
        };
        res.data.article.content = res.data.article.content.replace(
          /<(img|h[1-6]|a|hr)(\s|>)/gi,
          (match, tagName, spaceOrEnd) => `<${tagName} class="${tagClassMap[tagName]}"${spaceOrEnd}`
        );
        this.setData({
          data: res.data
        });
        this.excerpt_raw();
      }
    });
  },

  setNavigationBarColor() {
    const themeColor = Cache.get('themeColor') || '#406Eff';
    this.hexToRgb(themeColor);
    const textColor = Cache.get('textColor') || '#ffffff';
    this.setData({
      themeColor,
      textColor
    })
    this.changeBubbleColor(themeColor)
  },
  hexToRgb(hex) {
    console.log(hex)
    hex = hex.replace(/^#/, '');
    var bigint = parseInt(hex, 16);
    var r = (bigint >> 16) & 255;
    var g = (bigint >> 8) & 255;
    var b = bigint & 255;
    this.setData({
      boxshadow: `RGB(${r}, ${g}, ${b},0.2)`
    });
  },
  excerpt_raw() {
    const {
      excerpt_raw,
      content_raw
    } = this.data.data.article || {}; // 防止未定义时报错
    this.setData({
      displayedText: excerpt_raw ?
        excerpt_raw.substring(0, 100) :
        content_raw.substring(0, 100),
    });
  },
  changeBubbleColor(themeColor) {
    const newBubbleColor = this.adjustColor(themeColor, 20);
    this.setData({
      bubbleColor: newBubbleColor
    });
  },
  adjustColor(hex, amount) {
    const color = {
      r: Math.min(255, parseInt(hex.slice(1, 3), 16) + amount),
      g: Math.min(255, parseInt(hex.slice(3, 5), 16) + amount),
      b: Math.min(255, parseInt(hex.slice(5, 7), 16) + amount)
    };
    // 将 RGB 转换回十六进制
    return `#${[color.r, color.g, color.b].map(c => c.toString(16).padStart(2, '0')).join('')}`;
  },
  onShareAppMessage() {

  },
  onShareTimeline(){
    
  }
})