const Cache = require('../../utils/cache.js');
Page({
  data: {
    bubbleColor: '',
    animationData: {},
    themeColor: "#406Eff'",
    textColor: '#ffffff',
    navColor: 'transparent',
    popupVisible: false,
    page: 1,
    pageSize: "10",
    list: []
  },

  onShow() {
    this.setNavigationBarColor();
  },
  onLoad() {
    this.getData();
    this.getSetting();
  },
  shuaxin() {
    this.setData({
      navColor: this.data.themeColor,
      list:[],
      page:1,
      loading:true
    })
    this.getData();
  },
  getData() {
    let that = this; 
    this.setData({
      loading: true,
    });
    getApp().api.getListData({
      page: this.data.page,
      pageSize: this.data.pageSize
    }).then((res) => {
      wx.stopPullDownRefresh();
      setTimeout(function() {
            that.setData({
              loading: false,
              navColor: 'transparent'
            });
          }, 1000);

      if (res.data.articles.length > 0) {
        this.setData({
          list: this.data.list.concat(res.data.articles)
        });
      }
    })
  },
  getSetting() {
    let that = this; 
    getApp().api.getSetting().then((res) => {
      wx.stopPullDownRefresh();
      if (res.data) {
        this.setData({
          setting: res.data
        });
      }
    })
  },
  onPageScroll: function (e) {
    console.log(e)
    if (e.scrollTop > 10) {
      this.setData({
        navColor: this.data.themeColor
      })
    } else {
      this.setData({
        navColor: 'transparent'
      })
    }
    if (e.scrollTop > 439) {
      this.setData({
        isTop: false
      })
    } else {
      this.setData({
        isTop: true
      })
    }
  },
  showPopup() {
    this.setData({
      popupVisible: true
    });
  },
  setNavigationBarColor() {
    const themeColor = Cache.get('themeColor') || '#406Eff';
    const textColor = Cache.get('textColor') || '#ffffff';
    this.setData({
      themeColor,
      textColor
    })
    this.changeBubbleColor(themeColor)
  },

  changeBubbleColor(themeColor) {
    const newBubbleColor = this.adjustColor(themeColor, 20);
    this.setData({
      bubbleColor: newBubbleColor
    });
  },
  adjustColor(hex, amount) {
    const color = {
      r: Math.min(255, parseInt(hex.slice(1, 3), 16) + amount),
      g: Math.min(255, parseInt(hex.slice(3, 5), 16) + amount),
      b: Math.min(255, parseInt(hex.slice(5, 7), 16) + amount)
    };
    // 将 RGB 转换回十六进制
    return `#${[color.r, color.g, color.b].map(c => c.toString(16).padStart(2, '0')).join('')}`;
  },
  onReachBottom: function () {
    this.setData({
      page: this.data.page + 1
    });
    this.getData();
  },
  onShareAppMessage() {

  },
  onShareTimeline(){
    
  }
})