const Cache = require('../../utils/cache.js');
Page({
  data: {
    sorts: [],
    currentSortIndex: 0,
    currentSort: null,
    navColor: 'transparent',
    currentSortDesc: "",
    list:[]
  },
  onLoad() {
    this.getSortslist();
  },
  onShow() {
    this.setNavigationBarColor();
  },
  getSortslist() {
    getApp()
      .api.getSortslist({})
      .then((res) => {
        if (res.code === 0) {
          let sorts = res.data.sorts;
          let allSorts = [];
          sorts.forEach(item => {
            allSorts.push({
              ...item,
              type: 'parent'
            });
            if (item.children && Array.isArray(item.children)) {
              item.children.forEach(child => {
                allSorts.push({
                  ...child,
                  type: 'child'
                });
              });
            }
          });
          this.setData({
            sorts: allSorts
          });
          this.updateCurrentSort(0);
        } else {}
      })
      .catch(() => {
        wx.showToast({
          title: '加载失败',
          icon: 'none',
        });
      });
  },

  handleThumbnailClick(e) {
    const index = e.currentTarget.dataset.index;
    this.setData({
      page:1,
      list:[],
    })
    this.updateCurrentSort(index)
  },
getSortsBlogList(id) {
  getApp().api.getListData({
    page: this.data.page,
    sort_id: id || this.data.currentSort.sid
  }).then((res) => {
    if (!res.data) {
      this.setData({
        loading: false,
        navColor: 'transparent'
      });
    }
    if (res.data.articles.length > 0) {
      this.setData({
        list: this.data.list.concat(res.data.articles)
      });
    }
  })
},
  updateCurrentSort(index) {
    if(this.data.sorts[index].lognum == 0){
        index = index + 1
    }
    this.setData({
      currentSortIndex: index
    });
    const currentSort = this.data.sorts[index];
    this.setData({
      currentSort: currentSort
    });
    let currentSortDesc = "";
    currentSortDesc = currentSort.description;
    this.setData({
      currentSortDesc: currentSortDesc
    });
    this.getSortsBlogList();
  },
  setNavigationBarColor() {
    const themeColor = Cache.get('themeColor') || '#406Eff';
    const textColor = Cache.get('textColor') || '#ffffff';
    this.setData({
      themeColor,
      textColor
    })
    this.changeBubbleColor(themeColor)
  },
  changeBubbleColor(themeColor) {
    const newBubbleColor = this.adjustColor(themeColor, 20);
    this.setData({
      bubbleColor: newBubbleColor
    });
  },
  adjustColor(hex, amount) {
    const color = {
      r: Math.min(255, parseInt(hex.slice(1, 3), 16) + amount),
      g: Math.min(255, parseInt(hex.slice(3, 5), 16) + amount),
      b: Math.min(255, parseInt(hex.slice(5, 7), 16) + amount)
    };
    // 将 RGB 转换回十六进制
    return `#${[color.r, color.g, color.b].map(c => c.toString(16).padStart(2, '0')).join('')}`;
  },
  onReachBottom: function () {
    this.setData({
      page: this.data.page + 1
    });
    this.getSortsBlogList();
  },
  onPageScroll: function (e) {
    if (e.scrollTop > 10) {
      this.setData({
        navColor: this.data.themeColor
      })
    } else {
      this.setData({
        navColor: 'transparent'
      })
    }
    if (e.scrollTop > 439) {
      this.setData({
        isTop: false
      })
    } else {
      this.setData({
        isTop: true
      })
    }
  },

});