// pages/theme/theme.js
const Cache = require('../../utils/cache.js');
Page({
  data: {
    themeColor: '#406Eff',
    colors: [
      '#406Eff',
      '#9999FF',
      '#F17B68',
      '#70A19F',
      '#4A5B80'
    ],
    textcolors: ['#000000', '#ffffff'],
    newColor: '',
  },

  onLoad(options) {
    const themeColor = Cache.get('themeColor')||'#406Eff';
    const textColor = Cache.get('textColor')||'#ffffff';
    this.setData({
      themeColor: themeColor,
      textColor: textColor
    })
    const cachedColors = Cache.get('colors');
    const cachedTextColors = Cache.get('textcolors');
    if (cachedColors || cachedTextColors) {
      const newData = {};
      if (cachedColors) {
        newData.colors = cachedColors;
      }
      if (cachedTextColors) {
        newData.textcolors = cachedTextColors;
      }
      this.setData(newData);
    }
  },
  changeColor(e) {
    var color = e.currentTarget.dataset.color
    Cache.set('themeColor', color);
    this.setData({
      themeColor: color
    })
    wx.setNavigationBarColor({
      frontColor: '#ffffff',
      backgroundColor: color,
      animation: {
        duration: 400,
        timingFunc: 'easeIn'
      }
    })
  },
  changeTextColor(e) {
    var color = e.currentTarget.dataset.color
    Cache.set('textColor', color);
    this.setData({
      textColor: color
    })
    wx.setNavigationBarColor({
      frontColor: color,
      backgroundColor: this.data.themeColor,
      animation: {
        duration: 400,
        timingFunc: 'easeIn'
      }
    })
  },
  onReady() {

  },

  onShow() {
    const themeColor = Cache.get('themeColor')||'#406Eff';
    const textColor = Cache.get('textColor')||'#ffffff';
    wx.setNavigationBarColor({
      frontColor: textColor,
      backgroundColor: themeColor,
      animation: {
        duration: 400,
        timingFunc: 'easeIn'
      }
    })
  },
  toColorPicker() {
    wx.navigateTo({
      url: './colorPicker/color',
    });
  },
  removeColor() {
    var themeColor = '#406Eff';
    Cache.remove('colors');
    wx.setNavigationBarColor({
      frontColor: '#ffffff',
      backgroundColor: themeColor,
      animation: {
        duration: 400,
        timingFunc: 'easeIn'
      }
    })
    Cache.set('themeColor', themeColor);
    this.setData({
      themeColor: themeColor
    })
    this.setData({
      colors: [
        '#406Eff',
        '#9999FF',
        '#F17B68',
        '#70A19F',
        '#4A5B80'
      ],
    })
  },
  // 添加新颜色的方法，供子页面调用
  addNewColor(newColor) {
    const {
      colors
    } = this.data;
    const updatedColors = [...colors, newColor];
    this.setData({
      colors: updatedColors
    });
    Cache.set('colors', updatedColors);
  },


  onHide() {

  },
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})